// Copyright (c) 2019, Cthulhu
//
// Redistribution and use in source and binary forms,
// with or without modification,
// are permitted provided that the following conditions are met:
//
// 1. Redistributions of source code must retain the above copyright notice,
//    this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
//    this list of conditions and the following disclaimer in the documentation
//    and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
// FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
// IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
// ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION)
// HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

scope Items {
    // Items List
    constant NONE($00)
    constant BLADE_WOOD_SWORD($01)
    constant BLADE_IRON_BLADE($02)
    constant BLADE_STEELSABER($03)
    constant BLADE_LODE_SWORD($04)
    constant BLADE_RED_KATANA($05)
    constant BLADE_FLINT_EDGE($06)
    constant BLADE_DARK_SABER($07)
    constant BLADE_AEON_BLADE($08)
    constant BLADE_DEMON_EDGE($09)
    constant BLADE_ALLOYBLADE($0A)
    constant BLADE_STAR_SWORD($0B)
    constant BLADE_VEDICBLADE($0C)
    constant BLADE_KALI_BLADE($0D)
    constant BLADE_SHIVA_EDGE($0E)
    constant BLADE_BOLT_SWORD($0F)
    constant BLADE_SLASHER($10)
    constant BOW_BRONZE_BOW($11)
    constant BOW_IRON_BOW($12)
    constant BOW_LODE_BOW($13)
    constant BOW_ROBIN_BOW($14)
    constant BOW_SAGE_BOW($15)
    constant BOW_DREAM_BOW($16)
    constant BOW_COMETARROW($17)
    constant BOW_SONICARROW($18)
    constant BOW_VALKERYE($19)
    constant BOW_SIREN($1A)
    constant GUN_AIR_GUN($1F)
    constant GUN_DART_GUN($20)
    constant GUN_AUTO_GUN($21)
    constant GUN_PICOMAGNUM($22)
    constant GUN_PLASMA_GUN($23)
    constant GUN_RUBY_GUN($24)
    constant GUN_DREAM_GUN($25)
    constant GUN_MEGABLAST($26)
    constant GUN_SHOCK_WAVE($27)
    constant GUN_WONDERSHOT($28)
    constant GUN_GRAEDUS($29)
    constant ARM_TIN_ARM($2E)
    constant ARM_HAMMER_ARM($2F)
    constant ARM_MIRAGEHAND($30)
    constant ARM_STONE_ARM($31)
    constant ARM_DOOMFINGER($32)
    constant ARM_MAGMA_HAND($33)
    constant ARM_MEGATONARM($34)
    constant ARM_BIG_HAND($35)
    constant ARM_KAISER_ARM($36)
    constant ARM_GIGA_ARM($37)
    constant ARM_TERRA_ARM($38)
    constant ARM_CRISIS_ARM($39)
    constant SWORD_BRONZEEDGE($3B)
    constant SWORD_IRON_SWORD($3C)
    constant SWORD_MASAMUNE_1($3D)
    constant SWORD_FLASHBLADE($3E)
    constant SWORD_PEARL_EDGE($3F)
    constant SWORD_RUNE_BLADE($40)
    constant SWORD_BRAVESWORD($41)
    constant SWORD_MASAMUNE_2($42)
    constant SWORD_DEMON_HIT($43)
    constant FIST_1($44)
    constant FIST_2($45)
    constant FIST_3($46)
    constant FIST_IRON_FIST($47)
    constant FIST_BRONZEFIST($48)
    constant SCYTHE_DARKSCYTHE($4B)
    constant SCYTHE_HURRICANE($4C)
    constant SCYTHE_STARSCYTHE($4D)
    constant SCYTHE_DOOMSICKLE($4E)
    constant BLADE_MOP($4F)
    constant SWORD_BENT_SWORD($50)
    constant SWORD_BENT_HILT($51)
    constant SWORD_MASAMUNE($52)
    constant BLADE_SWALLOW($53)
    constant BLADE_SLASHER_2($54)
    constant BLADE_RAINBOW($55)
    constant ARMOR_HIDE_TUNIC($5B)
    constant ARMOR_KARATE_GI($5C)
    constant ARMOR_BRONZEMAIL($5D)
    constant ARMOR_MAIDENSUIT($5E)
    constant ARMOR_IRON_SUIT($5F)
    constant ARMOR_TITAN_VEST($60)
    constant ARMOR_GOLD_SUIT($61)
    constant ARMOR_RUBY_VEST($62)
    constant ARMOR_DARK_MAIL($63)
    constant ARMOR_MIST_ROBE($64)
    constant ARMOR_MESO_MAIL($65)
    constant ARMOR_LUMIN_ROBE($66)
    constant ARMOR_FLASH_MAIL($67)
    constant ARMOR_LODE_VEST($68)
    constant ARMOR_AEON_SUIT($69)
    constant ARMOR_ZODIACCAPE($6A)
    constant ARMOR_NOVA_ARMOR($6B)
    constant ARMOR_PRISMDRESS($6C)
    constant ARMOR_MOON_ARMOR($6D)
    constant ARMOR_RUBY_ARMOR($6E)
    constant ARMOR_RAVENARMOR($6F)
    constant ARMOR_GLOOM_CAPE($70)
    constant ARMOR_WHITE_MAIL($71)
    constant ARMOR_BLACK_MAIL($72)
    constant ARMOR_BLUE_MAIL($73)
    constant ARMOR_RED_MAIL($74)
    constant ARMOR_WHITE_VEST($75)
    constant ARMOR_BLACK_VEST($76)
    constant ARMOR_BLUE_VEST($77)
    constant ARMOR_RED_VEST($78)
    constant ARMOR_TABAN_VEST($79)
    constant ARMOR_TABAN_SUIT($7A)
    constant HELM_HIDE_CAP($7C)
    constant HELM_BRONZEHELM($7D)
    constant HELM_IRON_HELM($7E)
    constant HELM_BERET($7F)
    constant HELM_GOLD_HELM($80)
    constant HELM_ROCK_HELM($81)
    constant HELM_CERATOPPER($82)
    constant HELM_GLOW_HELM($83)
    constant HELM_LODE_HELM($84)
    constant HELM_AEON_HELM($85)
    constant HELM_PRISM_HELM($86)
    constant HELM_DOOM_HELM($87)
    constant HELM_DARK_HELM($88)
    constant HELM_GLOOM_HELM($89)
    constant HELM_SAFE_HELM($8A)
    constant HELM_TABAN_HELM($8B)
    constant HELM_SIGHT_CAP($8C)
    constant HELM_MEMORY_CAP($8D)
    constant HELM_TIME_HAT($8E)
    constant HELM_VIGIL_HAT($8F)
    constant HELM_OZZIEPANTS($90)
    constant HELM_HASTE_HELM($91)
    constant HELM_RBOW_HELM($92)
    constant HELM_MERMAIDCAP($93)
    constant ACCESSORY_BANDANA($95)
    constant ACCESSORY_RIBBON($96)
    constant ACCESSORY_POWERGLOVE($97)
    constant ACCESSORY_DEFENDER($98)
    constant ACCESSORY_MAGICSCARF($99)
    constant ACCESSORY_AMULET($9A)
    constant ACCESSORY_DASH_RING($9B)
    constant ACCESSORY_HIT_RING($9C)
    constant ACCESSORY_POWER_RING($9D)
    constant ACCESSORY_MAGIC_RING($9E)
    constant ACCESSORY_WALL_RING($9F)
    constant ACCESSORY_SILVERERNG($A0)
    constant ACCESSORY_GOLD_ERNG($A1)
    constant ACCESSORY_SILVERSTUD($A2)
    constant ACCESSORY_GOLD_STUD($A3)
    constant ACCESSORY_SIGHTSCOPE($A4)
    constant ACCESSORY_CHARM_TOP($A5)
    constant ACCESSORY_RAGE_BAND($A6)
    constant ACCESSORY_FRENZYBAND($A7)
    constant ACCESSORY_THIRD_EYE($A8)
    constant ACCESSORY_WALLET($A9)
    constant ACCESSORY_GREENDREAM($AA)
    constant ACCESSORY_BERSERKER($AB)
    constant ACCESSORY_POWERSCARF($AC)
    constant ACCESSORY_SPEED_BELT($AD)
    constant ACCESSORY_BLACK_ROCK($AE)
    constant ACCESSORY_BLUE_ROCK($AF)
    constant ACCESSORY_SILVERROCK($B0)
    constant ACCESSORY_WHITE_ROCK($B1)
    constant ACCESSORY_GOLD_ROCK($B2)
    constant ACCESSORY_HERO_MEDAL($B3)
    constant ACCESSORY_MUSCLERING($B4)
    constant ACCESSORY_FLEA_VEST($B5)
    constant ACCESSORY_MAGIC_SEAL($B6)
    constant ACCESSORY_POWER_SEAL($B7)
    constant ACCESSORY_RELIC($B8)
    constant ACCESSORY_SERAPHSONG($B9)
    constant ACCESSORY_SUN_SHADES($BA)
    constant ACCESSORY_PRISMSPECS($BB)
    constant TONIC($BD)
    constant MID_TONIC($BE)
    constant FULL_TONIC($BF)
    constant ETHER($C0)
    constant MID_ETHER($C1)
    constant FULL_ETHER($C2)
    constant ELIXIR($C3)
    constant HYPERETHER($C4)
    constant MEGAELIXIR($C5)
    constant HEAL($C6)
    constant REVIVE($C7)
    constant SHELTER($C8)
    constant POWER_MEAL($C9)
    constant LAPIS($CA)
    constant BARRIER($CB)
    constant SHIELD($CC)
    constant POWER_TAB($CD)
    constant MAGIC_TAB($CE)
    constant SPEED_TAB($CF)
    constant PETAL($D0)
    constant FANG($D1)
    constant HORN($D2)
    constant FEATHER($D3)
    constant SEED($D4)
    constant BIKE_KEY($D5)
    constant PENDANT($D6)
    constant GATE_KEY($D7)
    constant PRISMSHARD($D8)
    constant C_TRIGGER($D9)
    constant TOOLS($DA)
    constant JERKY($DB)
    constant DREAMSTONE($DC)
    constant RACE_LOG($DD)
    constant MOON_STONE($DE)
    constant SUN_STONE($DF)
    constant RUBY_KNIFE($E0)
    constant YAKRA_KEY($E1)
    constant CLONE($E2)
    constant TOMAS_POP($E3)
    constant 2_PETALS($E4)
    constant 2_FANGS($E5)
    constant 2_HORNS($E6)
    constant 2_FEATHERS($E7)
}

macro enemy(variable address, variable item, variable max) {
    seek(address)
        db item,max
}

// +++ Enemy Drops +++

enemy($CC5E04, Items.BLADE_MOP, 0)              // ($00) Nu
enemy($CC5E0B, Items.PETAL, 0)                  // ($01) Reptite
enemy($CC5E12, Items.NONE, 0)                   // ($02) Terrasaur
enemy($CC5E19, Items.PETAL, 0)                  // ($03) Kilwala
enemy($CC5E20, Items.MID_ETHER, inf)            // ($04) Krawlie
enemy($CC5E35, Items.NONE, 0)                   // ($07) Martello
enemy($CC5E3C, Items.NONE, 0)                   // ($08) Bellbird
enemy($CC5E43, Items.SPEED_TAB, inf)            // ($09) Panel
enemy($CC5E4A, Items.MEGAELIXIR, inf)           // ($0A) Mammon M.
enemy($CC5E5F, Items.NONE, 0)                   // ($0D) Green Imp
enemy($CC5E66, Items.NONE, 0)                   // ($0E) Stone Imp
enemy($CC5E6D, Items.SPEED_TAB, inf)            // ($0F) Mud Imp
enemy($CC5E74, Items.NONE, 0)                   // ($10) Roly
enemy($CC5E7B, Items.NONE, 0)                   // ($11) Poly
enemy($CC5E82, Items.NONE, 0)                   // ($12) Rolypoly
enemy($CC5E97, Items.NONE, 0)                   // ($15) Blue Eaglet
enemy($CC5E9E, Items.FEATHER, 0)                // ($16) Gold Eaglet
enemy($CC5EA5, Items.FEATHER, 0)                // ($17) Red Eaglet
enemy($CC5EC1, Items.NONE, 0)                   // ($1B) Bantam Imp
enemy($CC5EC8, Items.NONE, 0)                   // ($1C) Gnasher
enemy($CC5EE4, Items.NONE, 0)                   // ($20) Ruminator
enemy($CC5EF2, Items.NONE, 0)                   // ($22) Octopod
enemy($CC5F07, Items.MEGAELIXIR, inf)           // ($25) Zeal
enemy($CC5F0E, Items.PETAL, 0)                  // ($26) Fly Trap
enemy($CC5F15, Items.NONE, 0)                   // ($27) Meat Eater
enemy($CC5F1C, Items.NONE, 0)                   // ($28) Man Eater
enemy($CC5F31, Items.LAPIS, 0)                  // ($2B) Defunct
enemy($CC5F38, Items.LAPIS, 0)                  // ($2C) Departed
enemy($CC5F4D, Items.NONE, 0)                   // ($2F) Macabre
enemy($CC5F54, Items.NONE, 0)                   // ($30) Reaper
enemy($CC5F5B, Items.NONE, 0)                   // ($31) Guard
enemy($CC5F62, Items.NONE, 0)                   // ($32) Sentry
enemy($CC5F69, Items.NONE, 0)                   // ($33) Free Lancer
enemy($CC5F77, Items.ACCESSORY_WALL_RING, inf)  // ($35) Giga Mutant
enemy($CC5F7E, Items.ACCESSORY_HIT_RING, inf)   // ($36) Giga Mutant (Lower Body)
enemy($CC5F85, Items.ACCESSORY_MUSCLERING, inf) // ($37) TerraMutant
enemy($CC5F8C, Items.ACCESSORY_POWER_SEAL, inf) // ($38) TerraMutant (Lower Body)
enemy($CC5F9A, Items.SPEED_TAB, inf)            // ($3A) Retinite
enemy($CC5FA1, Items.BARRIER, 0)                // ($3B) Mage
enemy($CC5FAF, Items.NONE, 0)                   // ($3D) Reptite
enemy($CC5FB6, Items.NONE, 0)                   // ($3E) Blue Shield
enemy($CC5FBD, Items.NONE, 0)                   // ($3F) Yodu De
enemy($CC5FC4, Items.NONE, 0)                   // ($40) Incognito
enemy($CC5FE7, Items.NONE, 0)                   // ($45) Jinn Bottle
enemy($CC5FEE, Items.FEATHER, 0)                // ($46) Evilweevil
enemy($CC6003, Items.NONE, 0)                   // ($49) Gargoyle
enemy($CC6018, Items.NONE, 0)                   // ($4C) T'pole
enemy($CC601F, Items.2_FANGS, 0)                // ($4D) Croaker
enemy($CC6026, Items.2_HORNS, 0)                // ($4E) Amphibite
enemy($CC6042, Items.NONE, 0)                   // ($52) Scouter
enemy($CC6049, Items.NONE, 0)                   // ($53) Flyclops
enemy($CC605E, Items.SHIELD, 0)                 // ($56) Debuggest
enemy($CC6065, Items.NONE, 0)                   // ($57) Sorcerer
enemy($CC606C, Items.LAPIS, 0)                  // ($58) Jinn
enemy($CC6073, Items.SHIELD, 0)                 // ($59) Barghest
enemy($CC6088, Items.NONE, 0)                   // ($5C) Volcano
enemy($CC608F, Items.PETAL, 0)                  // ($5D) Shitake
enemy($CC6096, Items.NONE, 0)                   // ($5E) Hetake
enemy($CC609D, Items.NONE, 0)                   // ($5F) Rubble
enemy($CC60AB, Items.PETAL, 0)                  // ($61) Shist
enemy($CC60B2, Items.PETAL, 0)                  // ($62) Pahoehoe
enemy($CC60B9, Items.NONE, 0)                   // ($63) Nereid
enemy($CC60C7, Items.NONE, 0)                   // ($65) Mohavor
enemy($CC60E3, Items.NONE, 0)                   // ($69) Acid
enemy($CC60F1, Items.2_FEATHERS, 0)             // ($6B) Ion
enemy($CC60F8, Items.2_PETALS, 0)               // ($6C) Anion
enemy($CC6106, Items.HELM_HASTE_HELM, inf)      // ($6E) Lavos Spawn (Head) (Black Omen)
enemy($CC610D, Items.HELM_SAFE_HELM, inf)       // ($6F) Lavos Spawn (Black Omen)
enemy($CC6129, Items.NONE, 0)                   // ($73) Cave Bat
enemy($CC6130, Items.NONE, 0)                   // ($74) Ogan
enemy($CC6153, Items.FANG, 0)                   // ($79) Winged Ape
enemy($CC615A, Items.FANG, 0)                   // ($7A) Cave Ape
enemy($CC6161, Items.FANG, 0)                   // ($7B) Megasaur
enemy($CC6168, Items.NONE, 0)                   // ($7C) Omnicrone
enemy($CC616F, Items.HELM_RBOW_HELM, inf)       // ($7D) Beast
enemy($CC6176, Items.HELM_MERMAIDCAP, inf)      // ($7E) Blue Beast
enemy($CC617D, Items.ELIXIR, inf)               // ($7F) Red Beast
enemy($CC6184, Items.NONE, 0)                   // ($80) Turret
enemy($CC618B, Items.NONE, 0)                   // ($81) Lizardactyl
enemy($CC6199, Items.FEATHER, 0)                // ($83) Avian Rex
enemy($CC61A0, Items.BARRIER, 0)                // ($84) Blob
enemy($CC61A7, Items.MAGIC_TAB, inf)            // ($85) Alien
enemy($CC61BC, Items.HORN, 0)                   // ($88) Runner
enemy($CC61C3, Items.NONE, 0)                   // ($89) Proto 2
enemy($CC61CA, Items.NONE, 0)                   // ($8A) Proto 3
enemy($CC61D1, Items.BARRIER, 0)                // ($8B) Proto 4
enemy($CC61D8, Items.NONE, 0)                   // ($8C) Bug
enemy($CC61E6, Items.NONE, 0)                   // ($8E) Goon
enemy($CC61FB, Items.2_FEATHERS, 0)             // ($91) Rain Frog
enemy($CC6202, Items.NONE, 0)                   // ($92) Gato
enemy($CC6217, Items.MAGIC_TAB, inf)            // ($95) Golem
enemy($CC621E, Items.NONE, 0)                   // ($96) Synchrite
enemy($CC623A, Items.MAGIC_TAB, inf)            // ($9A) Azala
enemy($CC6241, Items.ACCESSORY_THIRD_EYE, inf)  // ($9B) Nizbel
enemy($CC6248, Items.ACCESSORY_THIRD_EYE, inf)  // ($9C) Nizbel II
enemy($CC625D, Items.NONE, 0)                   // ($9F) Flea
enemy($CC6264, Items.ACCESSORY_FLEA_VEST, inf)  // ($A0) Flea Plus
enemy($CC626B, Items.ACCESSORY_GOLD_STUD, inf)  // ($A1) Dalton
enemy($CC6272, Items.ACCESSORY_GOLD_STUD, inf)  // ($A2) Dalton Plus
enemy($CC6279, Items.NONE, 0)                   // ($A3) Mutant
enemy($CC6280, Items.NONE, 0)                   // ($A4) Metal Mute
enemy($CC6287, Items.BLADE_SLASHER_2, inf)      // ($A5) Super Slash
enemy($CC628E, Items.NONE, 0)                   // ($A6) Ozzie (Bridge)
enemy($CC6295, Items.NONE, 0)                   // ($A7) Ozzie
enemy($CC629C, Items.HELM_OZZIEPANTS, inf)      // ($A8) Great Ozzie
enemy($CC62AA, Items.BARRIER, 0)                // ($AA) Gigasaur
enemy($CC62B1, Items.SHIELD, 0)                 // ($AB) Leaper
enemy($CC62B8, Items.LAPIS, 0)                  // ($AC) Fossil Ape
enemy($CC62D4, Items.MEGAELIXIR, inf)           // ($B0) Zeal (Face)
enemy($CC62DB, Items.ARMOR_PRISMDRESS, inf)     // ($B1) Zeal (Right Hand)
enemy($CC62E2, Items.HELM_PRISM_HELM, inf)      // ($B2) Zeal (Left Hand)
enemy($CC6305, Items.ELIXIR, inf)               // ($B7) Display
enemy($CC630C, Items.ARMOR_NOVA_ARMOR, inf)     // ($B8) Mega Mutant
enemy($CC6313, Items.ARMOR_NOVA_ARMOR, inf)     // ($B9) Mega Mutant (Lower Body)
enemy($CC6328, Items.POWER_TAB, inf)            // ($BC) BlackTyrano
enemy($CC632F, Items.ARMOR_RED_MAIL, inf)       // ($BD) Rust Tyrano
enemy($CC6336, Items.ARMOR_BLUE_MAIL, inf)      // ($BE) MotherBrain
enemy($CC6344, Items.ACCESSORY_GOLD_ERNG, inf)  // ($C0) Atropos XR
enemy($CC634B, Items.POWER_MEAL, inf)           // ($C1) Cybot
enemy($CC6375, Items.ARMOR_WHITE_MAIL, inf)     // ($C7) Yakra XIII
enemy($CC637C, Items.POWER_TAB, inf)            // ($C8) Tubster
enemy($CC63BB, Items.SPEED_TAB, inf)            // ($D1) Giga Gaia
enemy($CC63D7, Items.NONE, 0)                   // ($D5) Red Scout
enemy($CC63DE, Items.NONE, 0)                   // ($D6) Blue Scout
enemy($CC63E5, Items.ELIXIR, inf)               // ($D7) Lavos Spawn
enemy($CC63EC, Items.ELIXIR, inf)               // ($D8) Lavos Spawn (Head)
enemy($CC63F3, Items.NONE, 0)                   // ($D9) Laser Guard
enemy($CC6486, Items.LAPIS, 0)                  // ($EE) Hexapod
enemy($CC64BE, Items.ARMOR_BLACK_MAIL, inf)     // ($F6) Son of Sun
enemy($CC64C5, Items.ELIXIR, inf)               // ($F7) Son of Sun (Prominence)
enemy($CC64DA, Items.MEGAELIXIR, inf)           // ($FA) Magus (North Cape)

// --- Enemy Drops ---
